##grid-react-interact

JSON API, OAuth api, Site Ui and mobile UI for grid-react


##OAuth API
All of the apis supported prepended with the path /api are protected by
OAuth 1.0a. To get your app added to the client list please ask me.


```javascript
OAuth endpoints:
{
  requestTokenURL: '/oauth/request_token',
  accessTokenURL: '/oauth/access_token',
  userAuthorizationURL: '/dialog/authorize',
  consumerKey: ask ,
  consumerSecret: ask
}
```

###GET /api/userinfo

Returns a JSON body with user information for the requester

###GET /api/socketkey

Returns a JSON body with an encrypted key that can be used to
authenticate with the grid-react-connector websocket server.
```javascript

return_body :  {status: 'ok', timestamp: socketKey.timestamp, socketKey: encryptedSocketKey}

```
###POST /api/sensor/:sensorMacAddress
###PUT /api/sensor/:sensorMacAddress
sensorMacAddress is a unique value for your account. Creates a sensor
that is hosted by your gateway. Updates the lastest reading of a sensor
or device.


```javascript
json_body : {
  payload: { type: 'MixedJsonReading' }
}
//Note MixedJsonReading must include a type parameter which is supported (int)
json_body_example : {
  payload : { type: 240, status: 'on' }
}
```


###GET /api/sensor

Returns a JSON array with all sensors
```javascript
json_body : 
[ { __v: 0,
    _id: '51266039b1cd498e49000002',
    lastReading: { type: 1, currentTemp: 77, setTemp: 60, setting: 2, relay1: 1 },
    mac: '0013a200408a7c91',
    name: 'Thermostat',
    type: 1,
    user: '512652cba46e449c02000001',
    createdAt: '2013-02-21T17:58:17.422Z' },
  { __v: 0,
    _id: '512660d6b1cd498e49000004',
    lastReading: { type: 2, mode: 0, event: 1 },
    mac: '0013a200407734cf',
    name: 'Button Display',
    type: 2,
    user: '512652cba46e449c02000001',
    createdAt: '2013-02-21T18:00:54.575Z' } ]


```

###GET /api/sensor/:sensorMacAddress

Returns a JSON body with the sensors latest reading

```javascript
query_params : [
  history : { type: [boolean],
              default: false,
              description: 'Makes the request return a history of the
              sensor instead of just the last reading'},
  limit: { type: int,
           default: 25,
           description: 'limits the amount of readings returned'
          }
]
```

###GET /api/action/:sensorMacAddress

returns the action file for a sensor

```javascript

json_body_params : 
{ actions: 
   [ { name: 'setString',
       type: 0,
       keys: 
        [ { name: 'line1',
            formtype: 'text',
            valuetype: 'string' },
          { name: 'line2',
            formtype: 'text',
            valuetype: 'string' },
          { name: 'timeout',
            formtype: 'slider',
            valuetype: 'float32',
            min: 0,
            max: 60000 } ] } ],
  sensor: 
   { __v: 0,
     _id: '512660d6b1cd498e49000004',
     lastReading: { type: 2, mode: 0, event: 1 },
     mac: '0013a200407734cf',
     name: 'Button Display',
     type: 2,
     user: '512652cba46e449c02000001',
     createdAt: '2013-02-21T18:00:54.575Z' } }

```
###POST /api/action/:sensorMacAddress/:actionName
Create an action to send to a gateway
```
json_body_params: {
//The params are completly defined by the keys returned in the action definition request
 { line1: 'hello', line2: 'world', timeout: '30000'}

}

```

Creates an action.

