/**
 * Module dependencies.
 */
var passport = require('passport')
  , login = require('connect-ensure-login')
  , sensorData = require('../../libs/sensorData.js')
  , sensorHelper = require('../helpers/sensorHelper')

exports.dashboard = function(req, res){
  var actions = []; 
  res.render('site/dashboard', {gateways: req.jsonResponse.gateways, sensors : req.jsonResponse.sensors, sensorData: sensorData, actions: actions});
};
exports.locations = function(req, res){

  res.render('site/locations', {currentlocation: req.location, locations : req.jsonResponse.locations,
                            sensors: req.jsonResponse.sensors, 
                            sensorData: sensorData});
};

exports.rules = function(req, res){

  res.render('site/rules', {currentrule: req.rule, rules : req.jsonResponse.rules,
                            sensors: req.jsonResponse.sensors, hooks: req.jsonResponse.hooks,
                            sensorData: sensorData});
};
exports.redirectRule = function(req, res){
  res.redirect("/site/rule/" + req.jsonResponse.currentrule);
}
exports.basicRule = function(req, res) {
  res.render('site/rule/basic', {
    sensors: req.jsonResponse.sensors,
    sensorData: sensorData,
    sensorHelper: sensorHelper});
}
exports.index = function(req, res) {
  res.send('OAuth Server');
};
exports.jsonResponse = function( req, res){
  res.json(req.jsonResponse);
}
exports.loginForm = function(req, res) {
  res.render('site/user/login');
};

exports.hookAdded = function(req, res){
    res.render('site/user/show', { user: req.user });
}

exports.login = passport.authenticate('local', { successReturnToOrRedirect: '/', failureRedirect: '/login' });

exports.logout = function(req, res) {
  req.logout();
  res.redirect('/');
}

exports.account = [
  login.ensureLoggedIn(),
  function(req, res) {
    res.render('site/users/show', { user: req.user });
  }
]
