// user schema

var mongoose = require('mongoose')
  , Schema = mongoose.Schema
  , _ = require('underscore')

var GatewaySchema = new Schema({
    name: {type: String, default: 'New Gateway'}
  , user: {type : Schema.ObjectId, ref: 'User'}
  , createdAt : {type : Date, default : Date.now}
  , lastSeen : {type : Date, default : Date.now}
  , status: {type: Schema.Types.Mixed}
  , drivers: {type: Schema.Types.Mixed}
  , socketId: String
  , socketServer: String
});

GatewaySchema.pre('save', function(next){
  // Always update time lastSeen
  this.lastSeen = Date.now;
  next();
});

mongoose.model('Gateway', GatewaySchema);
