/**
 * Module dependencies.
 */
var express = require('express'),
lessMiddleware = require('less-middleware'),
passport = require('passport'),
rack = require('asset-rack'),
categorizr = require('connect-categorizr'),
redis = require('../libs/event_queue_agent');
exports.boot = function(app,  passport) {
	bootApplication(app,  passport);
};

function bootApplication(app, passport) {
	console.log('booting express middleware');
  app.use(express.static(__dirname + '/../public'));
	app.set('views', __dirname + '/../app/views');
  app.set('view engine', 'jade');
	app.configure(function() {
    app.locals.pretty = true;
    app.locals.moment = require("moment");
		app.use(function(req, res, next) {
			res.locals.appName = 'Grid React';
			res.locals.title = 'Grid React';
			res.locals.showStack = app.showStackError;
			res.locals.req = req;
			next();
		});
    var jadeAssets = new rack.JadeAsset({
      url: '/js/jadeTemplates.js',
      dirname: __dirname + '/../app/views/site/shared'});
    
    jadeAssets.on('error', function(err){
      console.log('error with jade assets', err);
    });
    
    jadeAssets.on('complete', function(){
      console.log("jade assets complete");
    });

    app.use(jadeAssets);
		app.use(express.logger());
		app.use(express.cookieParser());
    app.use(express.json());
    app.use(express.urlencoded());
    var RedisStore = require('connect-redis')(express);
	  var redisOptions	= {client: redis.createClient()}
    app.use(express.session({
      store: new RedisStore(redisOptions),
			secret: 'oauth'
		}));
		app.use(passport.initialize());
		app.use(passport.session());
    app.use(categorizr());
		app.use(app.router);
    app.use(express.favicon());
		app.use(express.errorHandler({
			dumpExceptions: true,
			showStack: true
		}));
		app.use(function(err, req, res, next) {
			// treat as 404
			if (~err.message.indexOf('not found')) return next()
			// log it
			console.error(err.stack)
			// error page
			res.status(500).render('500')
		});

		// assume 404 since no middleware responded
		app.use(function(req, res, next) {
			res.status(404).render('404', {
				url: req.originalUrl
			});
		});

	});
	app.set('showStackError', true);
	// Passport configuration
}

