module.exports.actions = [

  {
    type: 'toggleThermostat',
    name: 'Toggle Thermostat',
    allowedEvents: ['any'],
    args: [
      {name: 'Thermostat', type: 'sensor_id', allowableTypes:[1]}
    ]
  },
  
  {
    type: 'display2Lines',
    name: 'Display on LED',
    allowedEvents: ['any'],
    args: [
      {name: 'Line 1', type: 'string'},
      {name: 'Line 2', type: 'string'},
      {name: 'User', type: 'uid'},
      {name: 'Display', type: 'sensor_mac', allowableTypes:[2]}
    ]
  },
  
  {
    type: 'playSound',
    name: 'Play Sound',
    allowedEvents: ['any'],
    args: [
      {name: 'Sound', type: 'enum', keys: ['Alarm', 'Beep', 'Doorbell'], values: ['alarm', 'beep', 'doorbell']},
      {name: 'User', type: 'uid'},
      {name: 'Speaker', type: 'sensor_mac', allowableTypes:[4]}
    ]
  },

  {
    type: 'blinkLights',
    name: 'Blink Light',
    allowedEvents: ['any'],
    args: [
      {name: 'Blink Type', type: 'enum', keys: ['true','false'], values: ['short','continuous']},
      {name: 'User', type: 'uid'},
      {name: 'Light', type: 'sensor_mac', allowableTypes:[240,241]}
    ]
  },
  
  {
    type: 'momentaryDimLight',
    name: 'Momentarily Dim Light',
    allowedEvents: ['any'],
    args: [
      {name: 'User', type: 'uid'},
      {name: 'Light', type: 'sensor_mac', allowableTypes:[240,241]}
    ]
  },
  
  {
    type: 'sendTextMessage',
    name: 'Send Text Message',
    allowedEvents: ['any'],
    args: [
      {name: 'Telephone Number', type: 'string'},
      {name: 'Message', type: 'string'}
    ]
  },

  {
    type: 'displayTemp',
    name: 'Display Temperature on LED',
    allowedEvents: ['sensor'],
    allowedSensorTypes: [1],
    args: [
      {name: 'Temperature', type: 'literal', value: '_object.currentTemp'},
      {name: 'Relay Power', type: 'literal', value: '_object.relay1'}
    ]
  },
  
  {
    type: 'displayCommit',
    name: 'Display Commit on LED',
    allowedEvents: ['hook'],
    allowedProviderTypes: ['github'],
    args: [
      {name: 'Repository', type: 'literal', value: '_object.repo'},
      {name: 'Commit', type: 'literal', value: '_object.commit'}
    ]
  }

];
