var redis = require('redis');
var ip;
var uuid = require('node-uuid');
function createClient(){
  var client = redis.createClient(null, ip, null);
  client.select(3, function(){});
  return client;
}

function boot(redisip){
  ip = redisip;
  var handler = require('./event_handler').getHandler();
  var pubclient = redis.createClient(null, redisip, null);
  pubclient.select(3, function(){});
  handler.on('action::new', function(evt){
   var event = { id: uuid.v1(), time: new Date().getTime(), act: evt};
   console.log("pushing action to queue");
   console.log(event);
   pubclient.rpush("actionQueue", JSON.stringify(event), function(){});
  });
  handler.on('event::new', function(evt){
   var event = { id: uuid.v1(), time: new Date().getTime(), evt: evt, type: 'sensor'};
   console.log("pushing event to queue");
   console.log(event);
   pubclient.rpush("eventQueue", JSON.stringify(event), function(){});
  });
}

module.exports.createClient = createClient;
module.exports.boot = boot;
