module.exports =  {
  1 : {
    sensorType: 'thermostat',
    name: 'Thermostat',
    reading:{
            type : 'uint8',
            currentTemp : 'float32',
            setTemp: 'float32',
            setting : 'uint8',
            relay1 : 'uint8'
    },
    display:[
      {name: 'Current Temp', key: 'currentTemp', type:'degree'}
    , {name: 'Set Temperature', key: 'setTemp', type: 'degree'}
    , {name: 'Setting', key : 'setting', type: 'enum',  keys: [0,1,2], values:['auto', 'off', 'on']}
    , {name: 'Relay Power', key : 'relay1', type: 'enum',  keys: [0,1], values:['off', 'on']}
    ],
    actions:[
      {  name: 'set',
        type: 0,
        keys:[
          {name: 'state', formtype: 'dropdown', valuetype: 'uint8', settings:['auto', 'off', 'on'], values:[0, 1, 2]},
          {name: 'setTemp', formtype: 'slider', valuetype:'float32', min:50, max:80, value:60 }
        ],
        order: ['state', 'setTemp']
      }
    ]
  },
  2 : {
    sensorType: 'pushButtonDisplay',
    name: 'Button Display',
    reading:{
            type : 'uint8',
            mode : 'uint8',
            event: 'uint8'
    },
    display:[
      {name: 'Current State', key: 'mode', type:'enum', keys: [0,1], values:['off', 'on']}
    ],
    actions:[
      {  name: 'setString',
        type: 0,
        keys:[
          {name: 'line1', formtype: 'text', valuetype: 'string' },
          {name: 'line2', formtype: 'text', valuetype: 'string' },
          {name: 'timeout', formtype: 'slider', valuetype: 'float32', min:0, max:60000 },
        ],
      }
    ]
  },
  3 : {
    sensorType: 'pushButton',
    name: 'Push Button',
    reading:{
            type : 'uint8',
            mode : 'uint8',
            event: 'uint8'
    },
    display:[
      {name: 'Current State', key: 'mode', type:'enum', keys: [0,1], values:['off', 'on']}
    ],
    actions:[
    ]
  },
  4 : {
    sensorType: 'pushButtonSpeaker',
    name: 'Button and Speaker',
    reading:{
            type : 'uint8',
            mode : 'uint8',
            event: 'uint8'
    },
    display:[
      {name: 'Current State', key: 'mode', type:'enum', keys: [0,1], values:['off', 'on']}
    ],
    actions:[
      { name: 'playSound',
        type: 0,
        keys: [
          {name: 'sound', formtype: 'dropdown', settings: ['Alarm', 'Beep', 'Doorbell'], values:['alarm', 'beep', 'doorbell']}
        ],
      }
    ]
  },
  12 : {
    sensorType: 'display',
    name: 'Display',
    reading:{
            type : 'uint8',
            mode : 'uint8',
            length: 'uint8',
            line1 : ['string', function(){ return this.current.length;}]
    },
    display:[
      {name: 'Current Display', key: 'line', type:'string'}
    ],
    actions:[
      {  name: 'setString',
        type: 0,
        keys:[
          {name: 'line1', formtype: 'text', valuetype: 'string' },
        ],
      }
    ]
  },
  240: {
    sensorType: 'Light',
    name: 'Light',
    reading: {
    },
    display:[
      {name: 'Light State', key: 'state', type: 'lightmulti'}
    ],
    actions:[
      { name: 'set',
        type: 0,
        keys: [
          {name: 'state', formtype: 'dropdown', valuetype: 'uint8', settings:['on', 'off'], values:[1, 0]},
          {name: 'color', formtype: 'colorpicker' , valuetype: 'na'}
        ],
      },
      { name: 'blink',
        type: 1,
        keys: [
          {name: 'duration', formtype: 'slider', valuetype: 'int', min: 0, max: 15000}
        ]
      },
      { name: 'dim',
        type: 1,
        keys: [
        ]
      },
      { name: 'party',
        type: 1,
        keys: [
          {name: 'duration', formtype: 'slider', valuetype: 'int', min: 0, max: 15000}
        ]
      }

    ]
  },
  241: {
    sensorType: 'Light',
    name: 'Lights (All)',
    reading: {
    },
    display:[
      {name: 'Light State', key: 'state', type: 'lightmulti'}
    ],
    actions:[
      { name: 'set',
        type: 0,
        keys: [
          {name: 'state', formtype: 'dropdown', valuetype: 'uint8', settings:['on', 'off'], values:[1, 0]},
          {name: 'color', formtype: 'colorpicker' , valuetype: 'na'}
        ],
      },
      { name: 'blink',
        type: 1,
        keys: [
          {name: 'duration', formtype: 'slider', valuetype: 'int', min: 0, max: 15000}
        ]
      },
      { name: 'dim',
        type: 1,
        keys: [
        ]
      },
      { name: 'party',
        type: 1,
        keys: [
          {name: 'duration', formtype: 'slider', valuetype: 'int', min: 0, max: 15000}
        ]
      },


    ]
  },
  242: {
    sensorType: 'SoundGateway',
    name: 'Sound Gateway',
    reading: {
    },
    display: [
    ],
    actions:[
      { name: 'play',
        type: 0,
        keys: [
          {name: 'sound', formtype: 'dropdown', settings: ['alarm', 'doorbell', '3birds','goodstuff', 'world' ], 
            values:['alarm.mp3', 'doorbell.mp3', '3birds.mp3', 'goodstuff.mp3', 'world.mp3']}
        ],
      },
      { name: 'stop',
        type: 1,
        keys: [
        ],
      }
    ]
  },
  300: {
    sensorType: 'GPIO',
    name: 'GPIO PINS',
    reading: {
    },
    display: [
    ],
    actions:[
      { name: 'pullup',
        type: 0,
        keys: [
          {name: 'pin', formtype: 'text', valuetype: "string"}
        ],
      },
      { name: 'pulldown',
        type: 0,
        keys: [
          {name: 'pin', formtype: 'text', valuetype: "string"}
        ],
      }
    ]
  },
  301: {
    sensorType: 'BLE_Detector',
    name: 'BLE Detector',
    reading: {
    },
    display:[
      {name: 'user', key: 'user', type:'string'},
      {name: 'inrange', key: 'inrange', type:'enum', keys: [0,1], values:['away', 'near']},
      {name: 'distance', key: 'distance', type:'string'},
      {name: 'beaconId', key: 'beaconId', type:'string'}
    ],
    actions:[
    ]
  }
}

