define([
       'jquery',
       'underscore',
       'backbone',
       'bootstrap',
       'Templater',
], function($, _, Backbone){
  var DashView = Backbone.View.extend({
    el: $('#dashboard-active'),
    events: {
      'submit .editsensor' : 'edit_sensor',
      'click .delete' : 'delete_sensor'
    },
    initialize: function(){
       
      console.log("dash view initialized");
      // huge hack because I can't figure out bootstrap modals and backbone
      $('.editsensor').on('submit', function(e){
        e.preventDefault();
        console.log(this);
        var self = this;
        var url = $(this).attr('action') 
        $.ajax({
          type: 'POST',
          url:url, 
          data :$(this).serialize(),
          success: function(data){
            if(data.result === 'success'){
              if(data.redraw === true){
                console.log($(self).parent())
                console.log("hiding modal");
                $(self).parent().modal('hide');
                $('.modal-backdrop').remove();
              }
            }else{
                $(self).parent().modal('hide');
            }
          },
          dataType: 'json'
        });
      });
      this.sensorData = JSON.parse(document.getElementById('sensor_data').innerText);



    },
    edit_sensor: function(e){
      var self = this;
      e.preventDefault();
      console.log("Editing sensor");
      console.log(this);
      var self = this;
      var url = $(this).attr('action') 
      $.ajax({
        type: 'POST',
        url:url, 
        data :$(this).serialize(),
        success: function(data){
          if(data.result === 'success'){
            if(data.redraw === true){
              $(self).parent().modal('hide');
              document.location.reload();
            }
          }else{
              $(self).parent().modal('hide');
          }
        },
        dataType: 'json'
      });
    },
    delete_sensor: function(e){
      console.log("clicked delete");
      console.log(this);
      var sensor  = this.getAttribute("data-sensor");

      e.preventDefault();
      console.log('Going to delete ' + sensor);
      var jqXhr = $.ajax({
        url: "/site/sensor/" + sensor,
        type: 'DELETE',
      });
      jqXhr.done(function(){
        console.log('sensor deleted');
        window.location = '/site/sensors';
      });
    },
    onSensorReading : function(sensor){
      var panel = $(".sensor_panel#"+ sensor._id);
      if(panel.length < 1) return createNewSensorPanel(sensor);

      var html = Templates["sensor_panel"]({sensorData: this.sensorData,
                                                   sensor: sensor});
      
      panel.html(html); 

    }

  });
  return DashView;
});
