
var mongoose = require('mongoose'),
    async = require('async'),
    fs = require('fs'),
    config = require('../config/conftool.js').getConf();

var models_path = __dirname + '/../app/models'
  , model_files = fs.readdirSync(models_path);

model_files.forEach(function(file) {
  require(models_path+'/'+file)
});
mongoose.connect(config.db);

var User = mongoose.model('User'),
    Sensor = mongoose.model('Sensor');
console.log("Starting load script");
//Create a test user

var createUser = function(cb){
  console.log('Creating test user... test/password');

  User.create({
                provider : 'local',
                name: 'Testy Tester',
                email: 'test@test.com',
                password: 'password'
  }, function(err, user){
    if(err){
      console.log(err);
    }
    console.log('Created test user... test@test.com with password "password"');
    cb(err, user._id);
  });
}

var createSensor = function(opts, cb){

  Sensor.create(opts, (function(err, obj){
    cb(err, obj.user);
    console.log('loaded sensor');
  }));
}

var sensor1 = function(userId, cb){
  var sensor = {
    mac: "0013a200407734cf",
    name: "Button Display",
    user: userId,
    lastReading: { "event" : 1, "mode" : 0, "type" : 2 }
  };
  createSensor(sensor, cb);
}
var sensor2 = function(userId, cb){
  var sensor = {
    mac: "0013a200407734ce",
    name: "Thermostat",
    user: userId,
    lastReading: { "relay1" : 0, "setting" : 1, "setTemp" : 60, "currentTemp" : 75.19999694824219, "type" : 1 }
  };
  createSensor(sensor, cb);
}
var sensor3 = function(userId, cb){
  var sensor = {
    mac: "cc1fe304ae7a5e96c7c2b9fab7827220:1",
    name: "Light1",
    user: userId,
    lastReading: { "pointsymbol" : { "1" : "none", "2" : "none", "3" : "none", "4" : "none", "5" : "none", "6" : "none", "7" : "none", "8" : "none" }, "swversion" : "65003148", "modelid" : "LCT001", "name" : "Hue Lamp 1", "type" : 240, "state" : { "reachable" : true, "colormode" : "hs", "effect" : "none", "alert" : "none", "ct" : 245, "xy" : [ 0.3784, 0.1831 ], "sat" : 224, "hue" : 54764, "bri" : 254, "on" : true }}
  };
  createSensor(sensor, cb);
}


async.waterfall( [createUser, sensor1, sensor2, sensor3], function(err, results){
  if(err){
    console.log('script failed');
    console.log(err);
  }else{
  mongoose.disconnect();
  console.log("finished loading");
  }
});
