/**
 * Module dependencies.
 */
var app = require('express')(),
    server = require('http').createServer(app),
    passport = require('passport'),
    fs = require('fs');
//Load Configs TODO  

var config = require('./config/conftool.js').getConf();
//bootstrap db TODO
var mongoose = require('mongoose'),
    Schema = mongoose.Schema;

mongoose.connect(config.db);

//bootstrap models TODO
var models_path = __dirname + '/app/models';
var model_files = fs.readdirSync(models_path); // jshint ignore:line
model_files.forEach(function(file) {
  require(models_path+'/'+file);
});

// Create Event service interface for local communication in network
var  GrEvents = require('gr-events');

var event_service = new GrEvents({http: require("express")(), listeners: config.grevents});

//require('./libs/event_queue_agent.js').boot(config.memory);
require('./config/auth').boot(passport,config);
//bootstrap express settings
require('./config/settings').boot(app, passport);
//bootstrap Interfaces
require('./interfaces/routes')(app, passport, event_service);

event_service.listen(3014);

var port = process.env.PORT || config.port;
server.listen(port);
console.log('server listening on port ' + port);
